<?php
//////////////////////////////////////////////////////////////////////////
//
//					LitePHP Core(Lite框架的主核心模块)
//					LitePHP 是一个轻量的框架
//					他追求的是速度,以及最方便的.
//					作者:Kelezyb
//					日期:2008/3/15 23:28
//
//////////////////////////////////////////////////////////////////////////

global $___lite_loaded_time;
$___lite_loaded_time = microtime();

header("content-type: text/html; charset=utf-8");
date_default_timezone_set('Etc/GMT-8');

define('DS', DIRECTORY_SEPARATOR);

define('IN_LITE', true);

/*	版本号	*/
$GLOBALS['LITE']['VERSION'] = '0.0.9.1';

/*	是否已经初始化	*/
$GLOBALS['LITE']['INIT'] = false;

/*	定义其组建的位置	*/
$GLOBALS['LITE']['LITE_PATH'] = dirname(__FILE__);		

/*	定义项目的导入路径	*/
$GLOBALS['LITE']['CLASS_PATH'] = array();

$GLOBALS['LITE']['LANGPATH'] = 'Lang';


/**
 * 导入路径到项目路径
 * 
 * @param string $path 导入的路径
 * 
 */
function import($path){
	if (array_search($path, $GLOBALS['LITE']['CLASS_PATH'], true)) { return; }	//是否以及存在路径
	$GLOBALS['LITE']['CLASS_PATH'][] = $path;
}	//{{

/**
 * 载入文件
 * 
 * @param string $fileName 类的名称
 * @param bool $isOne
 * @param bool $isAll
 * 
 * @param bool 只载入一次
 */
function _load($fileName, $isOne = true, $isAll = true){
	if (strtolower(substr($fileName, -4)) != '.php') {
		$fileName .= '.php';
	}
	
	$path = $GLOBALS['LITE']['LITE_PATH'] . DS . $fileName;
	if (is_file($path)) {
		if ($isOne) {				
			include_once($path);
		} else {
			include($path);
		}
		return true;
	}
	if($isAll){
		/*	尝试从导入路径中加载文件	*/
		foreach($GLOBALS['LITE']['CLASS_PATH'] as $path){
			$path = $path . DS . $fileName;
			//echo $path.'<br>';
			if (is_file($path)) {
				if ($isOne) {
					include_once($path);
				} else {
					include($path);
				}
				return true;
			}
		}
	}
	return false;
}	//{{

/**
 * 初始化系统
 * 
 */
function _init(){
	$GLOBALS['LITE']['INIT'] = true;
	loadConfig();
	loadHelper('LiteLib');
	loadHelper('LiteLog');
	loadHelper('LiteShort');
	loadHelper('LiteLang');
	loadHelper('LiteView');
}

/**
 * 执行LitePHP的快速MVC模式
 * 
 * @param int MVC模式的路径格式
 * 
 */
function runMVC($mode = 0){
	import('Module');
	if (!$GLOBALS['LITE']['INIT']){
		_init();
	}
	$mod = empty($_GET['mod']) ? 'index' : $_GET['mod'];	//需要载入的模块名称
	$action = empty($_GET['act']) ? 'index' : $_GET['act'];
	
	_initLang(_C('language'), $mod);	//初始化语言资源
	
	if (_load($mod)) {
		call_user_func(_C('actionprefix') . $action);
	} else {
		die('发生未知错误!');
	}
}	//{{

/**
 * 载入其他LitePHP其他模块
 * 
 * @param string $helper
 */
function loadHelper($helper) {
	return _load($helper, true, false);
}

/**
 * 载入系统配置
 * 
 * @param string $configFile
 */
function loadConfig($configFile = 'config.php'){
	$GLOBALS['LITE']['CONFIG'] = require($configFile);
}

?>